#!/usr/bin/perl

use Getopt::Std;
use List::Util shuffle;
use File::Basename;

our $root=(fileparse($0))[1];
$root=$ENV{MURASAKI} if $ENV{MURASAKI};
require "$root/config.pl";

$Getopt::Std::STANDARD_HELP_VERSION=true;
getopts('chn');
if($opt_h){HELP_MESSAGE();exit(0);}

($filename,$outfile)=@ARGV;

if($filename and -e $filename){
  $inseq=`$root/geneparse.pl -c $filename`;
  my ($basename,$path,$suffix) = fileparse($filename);
  $name="$basename-shuffled";
} else {
  print STDERR "File $filename not found. Waiting for input from stdin.\n" unless !$filename or $filename eq "-";
  while($_=<STDIN>){
    chomp;
    $inseq.=$_;
  }
  $name="stdin";
}
$outfile="-" unless $outfile;
if($opt_c){
  open(OUTF,">$outfile");
}else{
  open(OUTF,"|$root/faformat.pl --name=\"$name\" - $outfile");
}

$inseq=~s/[^atgc]//gi unless $opt_n;
print OUTF join("",shuffle(split(//,$inseq)));


sub main::HELP_MESSAGE(){
  print <<ENDTEXT
Usage: $0 [-c] [-n] [<in file>] [<out file>]

If you don't specify an infile or outfile, stdin/stdout is used.
 -c specifies clean output (ie: just the sequence)
 -n specifies to preserve non-atgc data.
     (Default behaviour is to eliminate them).
ENDTEXT
    ;
}

sub main::VERSION_MESSAGE(){
}
