#!/usr/bin/perl

use Getopt::Std;
use List::Util shuffle;

$Getopt::Std::STANDARD_HELP_VERSION=true;
getopts('chs:');
if($opt_h){HELP_MESSAGE();exit(0);}

srand($opt_s) if defined($opt_s);

($weight,$length,$file)=@ARGV;
($weight,$length,$file)=($1,$2,$length) if $weight=~m/\[(\d+):(\d+)\]/;
$zeros=$length-$weight;

$pat=join("",1,
	   shuffle((map {1} (1..$weight-2)),(map {0} (1..$zeros))),
    1);

if($opt_c){
  print $pat;
  exit(0);
}else{
  print "Weight: $weight\nLength: ".length($pat)."\n$pat\n";
  if($file){
    open(OF,">>$file");
    select OF;
    print "Weight: $weight\nLength: ".length($pat)."\n$pat\n";
  }
}

sub main::HELP_MESSAGE(){
  print <<ENDTEXT
Usage: $0 [-c] <weight> <length> [outputfile]
  -c specifies "clean output" ie only the pattern (and no newline)
As an alternative to specifying <weight> <length> and you can also use
the Murasaki format of [<weight>:<length>].
  -s specifies seed for random number generator

A neat trick for scripts is to use geneparse.pl to generate this for you.
 eg: ./murasaki -p`./geneparse.pl -m -f -e -c seq/humanY.fa`
ENDTEXT
    ;
}
  
  sub main::VERSION_MESSAGE(){
  }
